<template>
  <div class="q-pa-sm">
    <q-card
      bordered
      flat
    >
      <q-card-section>
        <div class="text-h5 text-weight-bolder text-grey-9 q-pa-sm">
          {{ title }}
        </div>
      </q-card-section>

      <q-card-section>
        <q-form class="row q-gutter-y-lg q-pb-md">
          <q-input
            v-model="value.name"
            :class="hasPwd ? 'col-6 q-pa-sm' : 'col-12 q-pa-sm'"
            label="Nome Completo"
            color="primary"
            bottom-slots
            outlined
            dense
            :error="vuelidate.name.$error"
          >
            <template v-slot:error>
              <div
                v-for="(errorMessage, index) in errorMessages(vuelidate.name)"
                :key="index"
              >
                {{ errorMessage }}
              </div>
            </template>
          </q-input>

          <q-input
            v-model="value.documentNumber"
            class="col-6 q-pa-sm"
            label="CPF"
            color="primary"
            mask="###.###.###-##"
            unmasked-value
            bottom-slots
            outlined
            dense
            :error="vuelidate.documentNumber.$error"
          >
            <template v-slot:error>
              <div
                v-for="(errorMessage, index) in errorMessages(vuelidate.documentNumber)"
                :key="index"
              >
                {{ errorMessage }}
              </div>
            </template>
          </q-input>

          <q-input
            ref="inputDate"
            v-model="value.bornAt"
            class="col-6 q-pa-sm"
            label="Data de Nascimento"
            color="primary"
            bottom-slots
            outlined
            dense
            :error="vuelidate.bornAt.$error"
            @focus="$refs.popupDate.show()"
          >
            <template v-slot:append>
              <q-icon
                class="cursor-pointer"
                name="event"
              >
                <q-popup-proxy
                  ref="popupDate"
                  transition-show="scale"
                  transition-hide="scale"
                  @hide="$refs.inputDate.blur()"
                >
                  <q-date
                    v-model="value.bornAt"
                    :default-year-month="defaultYearMonth"
                    :options="options"
                    mask="DD/MM/YYYY"
                    landscape
                    minimal
                    @input="$refs.popupDate.hide()"
                  />
                </q-popup-proxy>
              </q-icon>
            </template>

            <template v-slot:error>
              <div
                v-for="(errorMessage, index) in errorMessages(vuelidate.bornAt)"
                :key="index"
              >
                {{ errorMessage }}
              </div>
            </template>
          </q-input>

          <q-input
            v-model="value.phone.number"
            class="col-6 q-pa-sm"
            label="Telefone"
            color="primary"
            :mask="phoneMask"
            unmasked-value
            bottom-slots
            outlined
            dense
            :error="vuelidate.phone.number.$error"
          >
            <template v-slot:error>
              <div
                v-for="(errorMessage, index) in errorMessages(vuelidate.phone.number)"
                :key="index"
              >
                {{ errorMessage }}
              </div>
            </template>
          </q-input>

          <q-input
            v-model="value.email"
            class="col-6 q-pa-sm"
            label="E-mail"
            color="primary"
            bottom-slots
            outlined
            dense
            :error="vuelidate.email.$error"
          >
            <template v-slot:error>
              <div
                v-for="(errorMessage, index) in errorMessages(vuelidate.email)"
                :key="index"
              >
                {{ errorMessage }}
              </div>
            </template>
          </q-input>

          <q-input
            v-if="hasPwd"
            v-model="value.password"
            :type="isPwd ? 'password' : 'text'"
            class="col-6 q-pa-sm"
            label="Senha"
            color="primary"
            bottom-slots
            outlined
            dense
            :error="vuelidate.password.$error"
          >
            <template v-slot:append>
              <q-icon
                class="cursor-pointer"
                :name="isPwd ? 'visibility_off' : 'visibility'"
                @click="isPwd = !isPwd"
              />
            </template>

            <template v-slot:error>
              <div
                v-for="(errorMessage, index) in errorMessages(vuelidate.password)"
                :key="index"
              >
                {{ errorMessage }}
              </div>
            </template>
          </q-input>
        </q-form>
      </q-card-section>
    </q-card>
  </div>
</template>

<script>
import { ErrorMessagesMixin } from '../../mixin/error-messages'
import { isDate } from 'brazilian-values'
import { date } from 'quasar'

export default {
  name: 'User',
  mixins: [ErrorMessagesMixin],
  props: {
    value: {
      type: Object,
      default: () => ({})
    },
    vuelidate: {
      type: Object,
      default: () => ({})
    },
    title: {
      type: String,
      default: () => ('')
    },
    hasPwd: {
      type: Boolean,
      default: () => (false)
    }
  },
  data () {
    return {
      isPwd: true
    }
  },
  computed: {
    phoneMask () {
      return this.value.phone.number.length < 11 ? '(##) ####-#####' : '(##) #####-####'
    },
    defaultYearMonth () {
      return date.formatDate(date.subtractFromDate(new Date(), { year: 18 }), 'YYYY/MM')
    }
  },
  watch: {
    'value.bornAt' (bornAt) {
      if (!isDate(bornAt)) {
        this.value.bornAt = ''
      }
    }
  },
  methods: {
    options (optionDate) {
      return optionDate <= date.formatDate(date.subtractFromDate(new Date(), { year: 18 }), 'YYYY/MM/DD')
    }
  }
}
</script>
